#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>

#define IN_PORT 302    //for listen
#define OUT_PORT 303   //for send port
#define SERVER_ADDR "127.0.0.1"  //for send addr

int compare(float data, float mydata);

int main(){
	int listenfd;
	int newlistenfd;
	int sendfd;
	float data[2];
	float mydata[2] = {5.5, 7.7};
	int on = 1;
	int childpid;
	int count1 = 0, count2 = 0;
	int temp1 = 0, temp2 = 0, temp3 = 0, temp4 = 0, temp5 = 0;

	struct sockaddr_in serv_addr, cli_addr;
	struct sockaddr_in send_addr;	

	int clilen;
	clilen = sizeof(cli_addr);

	memset(&send_addr, 0, sizeof(send_addr));
	send_addr.sin_family = AF_INET;
	send_addr.sin_addr.s_addr = inet_addr(SERVER_ADDR);
	send_addr.sin_port = htons(OUT_PORT);

	if((sendfd = socket(AF_INET,SOCK_STREAM,0)) < 0)
		printf("sendfd socket\n");

	memset(&serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	serv_addr.sin_port = htons(IN_PORT);

	if((listenfd = socket(AF_INET,SOCK_STREAM,0)) == -1)
		printf("listenfd socket \n");
	if(setsockopt(listenfd, SOL_SOCKET,SO_REUSEADDR, &on, sizeof(on)) < 0 )
		printf("setsockopt\n");
	if(bind(listenfd,(struct sockaddr*)&serv_addr, sizeof(serv_addr)) < 0)
		printf("bin\n");
	for( ; ; ){
	if(listen(listenfd,8) < 0)
		printf("listening \n");

		newlistenfd = accept(listenfd,(struct sockaddr *)&cli_addr,(int *)&clilen);
		printf("temp1 : %d , ",temp1++);           //for test
		if(newlistenfd == -1)
			printf("accept\n");
		childpid = fork();
		printf("temp2 :%d, ",temp2++);           //for test
		recv(newlistenfd,&data,sizeof(data),0);
		if(childpid == 0){
			printf("temp3 : %d, ",temp3++);           //for test
			printf("%d received : %f, %f\n",count1++, data[0],data[1]);
			if( connect(sendfd,(struct sockaddr*)&send_addr,sizeof(send_addr)) < 0)
				printf("connect \n");
			else{
				printf("temp4 : %d, ",temp4++);           //for test
				send(sendfd,&mydata,sizeof(mydata),0);	
				printf("%d sended : %f, %f",count2++,mydata[0],mydata[1]);
			} //end of else
		shutdown(newlistenfd,SHUT_RD);
		shutdown(sendfd,SHUT_WR);

		} //end of if(childpid == 0)		
	} // end of for( ; ; )
} //end of in main
